## Script (Python) "html2pdf"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind state=state
##bind subpath=traverse_subpath
##parameters=
##title=html2pdf
##

REQUEST=context.REQUEST

from Products.CMFCore.utils import getToolByName

transformer = getToolByName(context, 'portal_transforms') 


add_link_list = False
if REQUEST:
   form = REQUEST.form
   if form and form.get('add_link_list',None):
      add_link_list = True

pdf = transformer.convertTo(target_mimetype = 'application/pdf',
                            orig = context,
                            mimetype = 'text/html',
                            add_link_list=add_link_list,
                           )

if pdf.getData() and pdf.getData().startswith('%PDF-'):
    REQUEST.RESPONSE.setHeader('Content-type','application/pdf')
    REQUEST.RESPONSE.setHeader('Content-disposition','inline; filename="%s.pdf"' % (context.title_or_id()))
    return pdf
else:
    request = context.REQUEST
    message = 'Error creating PDF file'
    return state.set(context = context, portal_status_message = message)

