import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.CMFPlone.tests import PloneTestCase
from AccessControl import Unauthorized, getSecurityManager
from Acquisition import aq_base
from DateTime import DateTime
from StringIO import StringIO

ZopeTestCase.installProduct('PortalTransforms')
ZopeTestCase.installProduct('MimetypesRegistry')
ZopeTestCase.installProduct('Plone2Pdf')

from Products.CMFCore.utils import getToolByName
from Acquisition import aq_base
from types import ListType, StringType, UnicodeType

class TestPlone2Pdf(PloneTestCase.PloneTestCase):
    """ Test (as much as we can) the Plone2Pdf product
    """
    
    def afterSetUp(self):    
        self.portal.portal_quickinstaller.installProduct('PortalTransforms')
        self.portal.portal_quickinstaller.installProduct('Plone2Pdf')
        self.portal.acl_users._doAddUser('user1', 'secret', ['Member'], [])
        self.membership = self.portal.portal_membership
        self.workflow = self.portal.portal_workflow
        self.createMemberarea('user1')

    content_to_be_created = [ ('document', 'Document') ]
    def testContentPlone2Pdf(self,):
        """
        Create a doc and vaguely test nothing
        Any idea for a real testing most welcome 
        """
        # Login
        self.login("user1")
        home = self.membership.getHomeFolder()

        # Content creation and trans
        for name_content, type_content in self.content_to_be_created:
            self.membership.getHomeFolder().invokeFactory(type_name = type_content, id = name_content)
            #self.assert_(type_content in self.portal.pdfConvertTypes())
            content = getattr(home, name_content)
            # ! this is not working !
            #pdf_meth = content.html2pdf            

    # for some reason portal.pdfConvertTypes() does not work ... why ?
    def testScriptsReturns(self):
        """ test the scripts returns """
        self.assert_(type(self.portal.portal_skins.Plone2Pdf.pdfConvertTypes()) is ListType)
    
    def testDirectConvert(self):
        """ hum ... """ 
        self.login("user1")
        home = self.membership.getHomeFolder()
        self.membership.getHomeFolder().invokeFactory(type_name = 'Document', id = 'doc')
        script = self.portal.portal_skins.Plone2Pdf.html2pdf   

        
# here is the *idea* of testing the transform ... not working yet ...
# from os.path import join, abspath, dirname, basename
# from Products.PortalTransforms.tests.test_transforms import TransformTest        
# from Products.PortalTransforms.tests.utils import load
# 
# PREFIX = abspath(dirname(__file__))
# 
# class TestPlone2PdfTransform(TransformTest):
#             input = join(PREFIX, 'input', 'demo.html')
#             output = join(PREFIX, 'output', 'demo.pdf')
#             transform = _transform = load('Products.Plone2Pdf.html_to_pdf').register()
#             normalize = None
#             subobjects = 0
    
def test_suite():
    # add my tests
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestPlone2Pdf))
    
    # add test transforms
    #suite.addTest(makeSuite(TestPlone2PdfTransform))

    return suite

if __name__ == '__main__':
    framework()
